(define (binary-tree->list tree)
  ; efficient version
  ; Space: Theta(n)
  ; Time:  Theta(n)
  (define (iter tail node)
    (check-binary-tree node)
    (if (empty-binary-tree? node)
        tail
        (begin
          (set! tail (iter tail (left-subtree node)))
          (set-cdr! tail (list (node-value node)))
          (iter (cdr tail) (right-subtree node)))))
  (let ((answer-handle (list '())))
    (iter answer-handle tree)
    (cdr answer-handle)))
