(define (binary-tree/fold op init tree)
  ; binary-tree/fold : (A,B,B)->B, B, binary-tree<A> -> B
  ;   op takes a node value and the accumulated results of the node's left
  ;   and right subtrees and creates a new accumulated result.
  (check-binary-tree tree)
  (if (empty-binary-tree? tree)
      init
      (op (node-value tree)
          (binary-tree/fold op init (left-subtree tree))
          (binary-tree/fold op init (right-subtree tree)))))